Subject: Re: [PATCH net-next v3 02/11] net: phy: introduce phy_has_c45_registers()

From: Michael Walle <[email-masked]>
Date: Wed, 19 Jul 2023 09:11:44 +0200

>> diff --git a/drivers/net/phy/phy-core.c b/drivers/net/phy/phy-core.c
>> index a64186dc53f8..686a57d56885 100644
>> --- a/drivers/net/phy/phy-core.c
>> +++ b/drivers/net/phy/phy-core.c
>> @@ -556,7 +556,7 @@ int __phy_read_mmd(struct phy_device *phydev, int 
>> devad, u32 regnum)
>> 
>>  	if (phydev->drv && phydev->drv->read_mmd) {
>>  		val = phydev->drv->read_mmd(phydev, devad, regnum);
>> -	} else if (phydev->is_c45) {
>> +	} else if (phy_has_c45_registers(phydev)) {
> 
> This i would say should be
> 
> phy_has_c45_transfers(phydev). This is about, can we do C45 transfers
> on the bus, and if not, fall back to C45 over C22.

Shouldn't this then be a bus property? I.e. mdiobus_has_c45_transfers().
I've have a similar helper introduced in 9/11:

static inline bool mdiobus_supports_c45(struct mii_bus *bus)
{
     return bus->read_c45 && !bus->prevent_c45_access;
}

>>  static int phylink_sfp_connect_phy(void *upstream, struct phy_device 
>> *phy)
>> diff --git a/include/linux/phy.h b/include/linux/phy.h
>> index 11c1e91563d4..fdb3774e99fc 100644
>> --- a/include/linux/phy.h
>> +++ b/include/linux/phy.h
>> @@ -766,6 +766,11 @@ static inline struct phy_device 
>> *to_phy_device(const struct device *dev)
>>  	return container_of(to_mdio_device(dev), struct phy_device, mdio);
>>  }
>> 
>> +static inline bool phy_has_c45_registers(struct phy_device *phydev)
>> +{
>> +	return phydev->is_c45;
>> +}
> 
> And this is where it gets interesting. I think as a first step, you
> should implement the four functions:
> 
> phy_has_c22_registers()
> phy_has_c45_registers()
> phy_has_c22_transfers()
> phy_has_c45_transfers()
> 
> based on this. So there is initially no functional change.
> 
> 
> You can then change the implementation of _transfers() based on what
> the MDIO bus can do, plus the quirk for if a FUBAR microchip PHY has
> been found.

See above. Shouldn't it be mdiobus_...() then?

> Then change the implementation of _registers() based on the results of
> probing for the ID registers.

So this is where I cannot follow. Right now there is
(1) probing via bus scan
(2) probing via DT (or maybe also ACPI)

With (1) you we have scan_c22(), so if successful, 
phy_has_c22_registers()
will return true, right? But it's not that clear for
phy_has_c45_registers(), because sometimes we prevent that scan. So
the PHY might have c45 but we don't know.

For (2) we don't even do a c22 scan if we know if its a C45 PHY (or the
other way around). I'm not sure we can reliably tell (at the end of this
series) if a phy has c22 register, c45 registers or both.

-michael

> That should give us a basis for a clean separation between register
> spaces and bus transaction, and then adding C45 over C22 should be
> more obviously correct.
> 
> 	Andrew